unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, math,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  VCLTee.TeeSurfa, VCLTee.TeeProcs, VCLTee.Chart, Vcl.ExtCtrls, Vcl.StdCtrls,
  VCLTee.TeeEdit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Chart1: TChart;
    Series1: TColorGridSeries;
    Button1: TButton;
    Button2: TButton;
    ChartEditor1: TChartEditor;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    procedure ImgReset;
    procedure DisplayData;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  PaletteMin = -15;
  PaletteIncr = 2;
  PaletteSteps = 25;

  DefaultColorPalette : Array[1..256] of TColor = (
    $000000, $500000, $550000, $100000, $150000, $1A0000, $200000, $250000, $2A0000,
    $300000, $350000, $3A0000, $400000, $450000, $4A0000, $500000, $550000, $5A0000,
    $600000, $650000, $6A0000, $700000, $750000, $7A0000, $800000, $850000, $8A0000,
    $900000, $950000, $9A0000, $A00000, $A50000, $AA0000, $B00000, $B50000, $BA0000,
    $C00000, $C50000, $CA0000, $D00000, $D50000, $DA0000, $E00000, $E50000, $EA0000,
    $F00000, $F50000, $FA0000, $FF0000, $FF0800, $FF1000, $FF1200, $FF1500, $FF1A00,
    $FF2000, $FF2500, $FF2A00, $FF3000, $FF3500, $FF3A00, $FF4000, $FF4500, $FF4A00,
    $FF5000, $FF5500, $FF5A00, $FF6000, $FF6500, $FF6A00, $FF7000, $FF7500, $FF7A00,
    $FF8000, $FF8500, $FF8A00, $FF9000, $FF9500, $FF9A00, $FFA000, $FFA500, $FFAA00,
    $FFB000, $FFB500, $FFBA00, $FFC000, $FFC500, $FFCA00, $FFD000, $FFD500, $FFDA00,
    $FFE000, $FFE500, $FFEA00, $FFF000, $FFF500, $FFFA00, $FFFF00, $FAFF00, $F5FF00,
    $F0FF00, $EAFF00, $E5FF00, $E0FF00, $DAFF00, $D5FF00, $D0FF00, $CAFF00, $C5FF00,
    $C0FF00, $BAFF00, $B5FF00, $B0FF00, $AAFF00, $A5FF00, $A0FF00, $9AFF00, $95FF00,
    $90FF00, $8AFF00, $85FF00, $80FF00, $7AFF00, $75FF00, $70FF00, $6AFF00, $65FF00,
    $60FF00, $5AFF00, $55FF00, $50FF00, $4AFF00, $45FF00, $40FF00, $3AFF00, $35FF00,
    $30FF00, $2AFF00, $25FF00, $20FF00, $1AFF00, $15FF00, $10FF00, $0AFF00, $05FF00,
    $00FF00, $00FF05, $00FF0A, $00FF10, $00FF15, $00FF1A, $00FF20, $00FF25, $00FF2A,
    $00FF30, $00FF35, $00FF3A, $00FF40, $00FF45, $00FF4A, $00FF50, $00FF55, $00FF5A,
    $00FF60, $00FF65, $00FF6A, $00FF70, $00FF75, $00FF7A, $00FF80, $00FF85, $00FF8A,
    $00FF90, $00FF95, $00FF9A, $00FFA0, $00FFA5, $00FFAA, $00FFB0, $00FFB5, $00FFBA,
    $00FFC0, $00FFC5, $00FFCA, $00FFD0, $00FFD5, $00FFDA, $00FFE0, $00FFE5, $00FFEA,
    $00FFF0, $00FFF5, $00FFFF, $00FAFF, $00F5FF, $00F0FF, $00EAFF, $00E5FF, $00E0FF,
    $00DAFF, $00D5FF, $00D0FF, $00CAFF, $00C5FF, $00C0FF, $00BAFF, $00B5FF, $00B0FF,
    $00AAFF, $00A5FF, $00A0FF, $009AFF, $0095FF, $0090FF, $008AFF, $0085FF, $0080FF,
    $007AFF, $0075FF, $0070FF, $006AFF, $0065FF, $0060FF, $005AFF, $0055FF, $0050FF,
    $004AFF, $0045FF, $0040FF, $003AFF, $0035FF, $0030FF, $002AFF, $0025FF, $0020FF,
    $001AFF, $0015FF, $0010FF, $000AFF, $0005FF, $0000FF, $1111FF, $2222FF, $3333FF,
    $4444FF, $5555FF, $6666FF, $7777FF, $8888FF, $9999FF, $AAAAFF, $BBBBFF, $CCCCFF,
    $DDDDFF, $EEEEFF, $FFFFFF, $FFFFFF);



procedure TForm1.Button1Click(Sender: TObject);
begin
  ImgReset;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ChartEditor1 := tChartEditor.Create(self);
  try
    ChartEditor1.Chart := Chart1;
    ChartEditor1.Series := Chart1.Series[0];
    ChartEditor1.Execute;
  finally
    ChartEditor1.Free;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  DisplayData;
end;


procedure TForm1.ImgReset;
var
  k, l, m : Integer;

begin
  Chart1.Series[0].BeginUpdate;

  // When clear is called, palette information is lost.  Is there a way to
  // clear the data without loosing the palette setup?
//
//   Chart1.Series[0].Clear;

  if (Chart1.Series[0] as TColorGridSeries).XValues.Count > 0 then
    begin
      (Chart1.Series[0] as TColorGridSeries).XValues.Delete(0, (Chart1.Series[0] as TColorGridSeries).XValues.Count);
      (Chart1.Series[0] as TColorGridSeries).YValues.Delete(0, (Chart1.Series[0] as TColorGridSeries).YValues.Count);
      (Chart1.Series[0] as TColorGridSeries).ZValues.Delete(0, (Chart1.Series[0] as TColorGridSeries).ZValues.Count);
    end;

  Chart1.Series[0].Pen.Visible := False;
  Chart1.Series[0].HasZValues := True;
  (Chart1.Series[0] as TColorGridSeries).SmoothBitmap := True;
  (Chart1.Series[0] as TColorGridSeries).CenteredPoints := False;
  (Chart1.Series[0] as TColorGridSeries).PaletteMin := PaletteMin;
  (Chart1.Series[0] as TColorGridSeries).PaletteStep := PaletteIncr;
  (Chart1.Series[0] as TColorGridSeries).PaletteSteps := PaletteSteps;
  (Chart1.Series[0] as TColorGridSeries).UseColorRange := False;
  (Chart1.Series[0] as TColorGridSeries).UsePalette := True;
  (Chart1.Series[0] as TColorGridSeries).UsePaletteMin := True;
  (Chart1.Series[0] as TColorGridSeries).LegendEvery := 1;
  (Chart1.Series[0] as TColorGridSeries).SmoothBitmap := False;
  (Chart1.Series[0] as TColorGridSeries).CenteredPoints := False;
  (Chart1.Series[0] as TColorGridSeries).ClearPalette();

  m := 1;
  l := Max(Length(DefaultColorPalette) div PaletteSteps, 1);
  for k := 0 to PaletteSteps-1 do
    begin
      (Chart1.Series[0] as TColorGridSeries).AddPalette(PaletteMin+(k)*PaletteIncr, DefaultColorPalette[m]);
      Inc(m,l);
      if m > High(DefaultColorPalette) then
        m := High(DefaultColorPalette)
    end;

  Chart1.Series[0].EndUpdate;
  Chart1.Repaint;
end;

procedure TForm1.DisplayData;
const
  NumX=50;
  NumZ=50;

var
  x,z,
  k,l,m : Integer;

begin
  Series1.BeginUpdate;

  for x:=1 to NumX do
    for z:=1 to NumZ do
      Series1.AddXYZ( x,
                      cos(0.14*x)*cos(0.25*z)+
                      0.01*(x-(NumX div 2))*(z-(NumZ div 2)) +
                      13*exp(-0.06*(sqr(x-(NumX div 2))+sqr(z-(NumZ div 2))))+
                      6*exp(-0.03*(sqr(x-(NumX div 3))+sqr(z-3*(NumZ div 5))))-1,
                      z );

  Series1.EndUpdate;
  Chart1.Repaint;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  x,z,
  k,l,m : Integer;

begin
  ImgReset;
  DisplayData;
end;

end.

